import 'dart:io';

class Router {
  var myView;
  var errorPage;
  bool logger;
  String params_uri;
  String params_file;
  Map myConfig;

  Router(this.myView, this.errorPage) {
    print('Router init');
    this.myView = new Directory(this.myView).uri;
    this.errorPage = File('${myView}/${this.errorPage}.html');
  }

  Future router([logger = false]) async {
    var server = await HttpServer.bind(InternetAddress.loopbackIPv6, 3000);
    print('Listening on http://localhost:${server.port}');

    await for (HttpRequest request in server) {
      logger == true ? print('Router logger : ${request.uri.path}') : '';
      var i;
      var sortedKeys = myConfig.keys.toList();
      var sortedValues = myConfig.values.toList();
      if (myConfig.containsKey(request.uri.path)) {
        for (i = 0; i < sortedKeys.length; i++) {
          if (sortedKeys[i] == request.uri.path) {
            File myFile = File('${myView}/${sortedValues[i]}.html');
            openHtmlFile(myFile, request);
            break;
          } else {
            continue;
          }
        }
      } else {
        openHtmlFile(errorPage, request);
      }
    }
  }

  config(config) {
    this.myConfig = config;
    print('Config set');
  }

  openHtmlFile(file, request) {
    file.readAsString().then((contents) {
      request.response.headers.contentType = ContentType.html;
      request.response.write(contents);
      request.response.close();
    });
  }
  
}
